
#define SONGNAME_LEN 64

struct note_t
{
  char filename[1024];
  char outname[1024];
  char songname[SONGNAME_LEN];
  char channels;
  int sample_rate;
  unsigned int samples_per_beat;
  int bpm;
  int pause;
  int bytes;
  int scale;
  int prev_scale;
  int tone;
  int length;
  int modifier;
  int style;
  int transpose;
  int flats;
  int volume;
  int a440,ats;
  int width,height,mcc,mnc,bmp_flags;
  int note_count;
  int marker;
  int ems;
};

int write_long(FILE *out, int n);
int write_word(FILE *out, int n);
int read_long(FILE *in);
int read_word(FILE *in);
int write_long_b(FILE *out, int n);
int write_word_b(FILE *out, int n);
int read_long_b(FILE *in);
int read_word_b(FILE *in);
int read_chars(FILE *in, char *s, int count);
int write_chars(FILE *out, char *s);

void write_wav_header(FILE *out, struct note_t *note);
void write_wav_note(FILE *out, struct note_t *note);
void write_wav_footer(FILE *out, struct note_t *note);

void write_kws_header(FILE *out, struct note_t *note);
void write_kws_note(FILE *out, struct note_t *note);
void write_kws_footer(FILE *out, struct note_t *note);

void write_mot_header(FILE *out, struct note_t *note);
void write_mot_note(FILE *out, struct note_t *note);
void write_mot_footer(FILE *out, struct note_t *note);

void write_rtttl_header(FILE *out, struct note_t *note);
void write_rtttl_note(FILE *out, struct note_t *note);
void write_rtttl_footer(FILE *out, struct note_t *note);
void write_rtx_bpm(FILE *out, struct note_t *note);

void write_samsung_header(FILE *out, struct note_t *note);
void write_samsung1_note(FILE *out, struct note_t *note);
void write_samsung2_note(FILE *out, struct note_t *note);
void write_samsung_footer(FILE *out, struct note_t *note);

void write_siemens_header(FILE *out, struct note_t *note);
void write_siemens_note(FILE *out, struct note_t *note);
void write_siemens_footer(FILE *out, struct note_t *note);

void write_mot_key_header(FILE *out, struct note_t *note);
void write_mot_key_note(FILE *out, struct note_t *note);
void write_mot_key_footer(FILE *out, struct note_t *note);

void write_emelody_header(FILE *out, struct note_t *note);
void write_emelody_note(FILE *out, struct note_t *note);
void write_emelody_footer(FILE *out, struct note_t *note);

void write_imelody_header(FILE *out, struct note_t *note);
void write_imelody_note(FILE *out, struct note_t *note);
void write_imelody_footer(FILE *out, struct note_t *note);

void write_nokia_header(FILE *out, struct note_t *note);
void write_nokia_note(FILE *out, struct note_t *note);
void write_nokia_footer(FILE *out, struct note_t *note);
void write_nokia_bpm(FILE *out, struct note_t *note);
void write_nokia_volume(FILE *out, struct note_t *note);

void write_midi_header(FILE *out, struct note_t *note);
void write_midi_note(FILE *out, struct note_t *note);
void write_midi_footer(FILE *out, struct note_t *note);
void write_midi_bpm(FILE *out, struct note_t *note);

void write_3210_header(FILE *out, struct note_t *note);
void write_3210_note(FILE *out, struct note_t *note);
void write_3210_footer(FILE *out, struct note_t *note);

int header_route(FILE *out, struct note_t *note, int in_type, int file_type);
int note_route(FILE *out, struct note_t *note, int in_type, int file_type);
int footer_route(FILE *out, struct note_t *note, int in_type, int file_type);
int tempo_route(FILE *out, struct note_t *note, int in_type, int file_type);
int volume_route(FILE *out, struct note_t *note, int in_type, int file_type);

void write_ems(char *s);
void write_ems_footer(FILE *out, struct note_t *note);
void write_ems_logo_footer(FILE *out, struct note_t *note);

int parse_rtttl(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_imelody(FILE *in, FILE *out, int file_type, struct note_t *note);
int wav2pdb(FILE *in, FILE *out, struct note_t *note);
int parse_logo(FILE *in, FILE *out, int in_type, int file_type, struct note_t *note, char *message);
int parse_midi(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_kws(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_wav(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_siemens(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_emelody(FILE *in, FILE *out, int file_type, struct note_t *note);
int parse_3210(FILE *in, FILE *out, int file_type, struct note_t *note);
int create_seo(FILE *in, FILE *out, int in_type, struct note_t *note);


