#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "general.h"
#include "fileoutput.h"
#include "nokia.h"

/*

bmp2nokia_icon - Copyright 2001-2003 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int parse_text(FILE *fp, struct note_t *note, char *picture)
{
int t,x,y,lastch,ch;
int ptr=0;

  while ((ch=getc(fp))!=EOF)
  {
    if (ch=='\n' || ch=='\r')
    {
      if ((lastch=='\r' || lastch=='\n') && ch!=lastch) continue;
      for (t=x; t<note->width; t++) picture[ptr++]=' ';
      x=0; y++;
      continue;
    }

    if (ch==' ')
    { picture[ptr++]=' '; }
      else
    { picture[ptr++]='*'; }

    x++;

    if (x>=note->width)
    {
      while ((ch=getc(fp))!=EOF)
      { if (ch=='\n' || ch=='\r') break; }
      y++;
      if (y>=note->height) break;
      x=0;
    }

    lastch=ch;
  }

  for (t=y; t<note->height; t++)
  {
    for (x=0; x<note->width; x++) picture[ptr++]=' ';
  }

  return 0;
}

int parse_logo(FILE *in, FILE *out, int in_type, int file_type, struct note_t *note, char *message)
{
int x,y,reverse;
char picture[8192];

  if ((note->bmp_flags&1)==1)
  { reverse=1; }
    else
  { reverse=0; }

  if (file_type==14)
  {
    if (note->width>16 || note->height>16)
    {
      note->width=32;
      note->height=32;
      note->ems=3;
      if (quiet==0) printf("Cropping picture to 32x32.\n");
    }
      else
    {
      note->width=16;
      note->height=16;
      note->ems=2;
      if (quiet==0) printf("Cropping picture to 16x16.\n");
    }
  }

#ifdef DEBUG
  printf("         Width: %d\n",note->width);
  printf("        Height: %d\n",note->height);
  printf("      SMS Size: %d\n",full_sms_size);
#endif

  if (note->mcc!=-1 && note->mnc!=-1)
  {
#ifdef DEBUG
    printf("       MCC MNC: %d %d\n",note->mcc,note->mnc);
#endif
  }

  if (file_type==4)
  { write_nokia_logo_header(out,note,message); }

  if (in_type==3)
  {
    if (parse_bitmap(in,note->width,note->height,picture)==-1)
    {
      printf("Could not read BMP.\n");
      return -1; 
    }

    for (y=note->height-1; y>=0; y--)
    {
      for (x=0; x<note->width; x++)
      {
        if (picture[(y*note->width)+x]==' ')
        {
          push(1^reverse,1);
        }
          else
        {
          push(0^reverse,1);
        }
      }
    }
  }
    else
  if (in_type==4)
  {
    parse_text(in,note,picture);

    for (y=0; y<note->height; y++)
    {
      for (x=0; x<note->width; x++)
      {
        if (picture[(y*note->width)+x]==' ')
        {
          push(1^reverse,1);
        }
          else
        {
          push(0^reverse,1);
        }
      }
    }
  }

#ifdef DEBUG
  printf("\n");
#endif


#ifdef DEBUG
  for (y=note->height-1; y>=0; y--)
  {
    for (x=0; x<note->width; x++)
    {
      if (picture[(y*note->width)+x]==' ')
      {
        printf("_");
      }
        else
      {
        printf("*");
      }
    }
    printf("\n");
  }
#endif

  if (file_type==4) write_nokia_logo_codes(out,note);
    else
  if (file_type==14) write_ems_logo_footer(out,note);

  return (0);
}



